From dc9dcd3e8e8b648ef410c1b01d63a6c7bd41f94b Mon Sep 17 00:00:00 2001
From: Nathan Bossart <bossartn@amazon.com>
Date: Thu, 20 Jan 2022 20:32:39 +0000
Subject: [PATCH v3 1/1] persist directory entries for logical rewrite files to
 disk during checkpoints

---
 src/backend/access/heap/rewriteheap.c | 3 +++
 1 file changed, 3 insertions(+)

diff --git a/src/backend/access/heap/rewriteheap.c b/src/backend/access/heap/rewriteheap.c
index aa265edf60..2a53826736 100644
--- a/src/backend/access/heap/rewriteheap.c
+++ b/src/backend/access/heap/rewriteheap.c
@@ -1282,4 +1282,7 @@ CheckPointLogicalRewriteHeap(void)
 		}
 	}
 	FreeDir(mappings_dir);
+
+	/* persist directory entries to disk */
+	fsync_fname("pg_logical/mappings", true);
 }
-- 
2.16.6

